/*
 * Programma per la gestione di sequenze. GSeq permette di inserire,
 * cercare ed eliminare elementi in una sequenza. La sequenza pu
 * anche essere letta o salvata da/su file.
 *
 * Vedere la documentazione della funzione ::main per maggiori dettagli
 * sulle funzionalit e sulla loro implementazione.
 */

/*
 * File contenente il modulo Main.
 */

#include <iostream>
#include <fstream>
#include <cstring>
#include <stdlib.h>



using namespace std ;

#include "strutt_dati.h"
#include "manip_stampa.h"
#include "fileIO.h"

/* Funzione principale
 * Stampa un men con tutte le funzionalit disponibili. Tali
 * funzionalit sono:
 * - inserimento, implementato mediante la funzione ::inserisci
 * - ricerca, implementata mediante la funzione ::cerca
 * - eliminazione, implementata mediante la funzione ::elimina
 * - stampa, implementata mediante la funzione ::stampa
 * - caricamento da file, per ora non implementata
 * - salvataggio su file, implementata mediante la funzione ::salva
 */
int main()
{
    desc_sequenza sequenza ;

    int scelta ;
    do {
	cout<<"Tipo di chiave: "<<endl ;
	cout<<"\t1) Numerica"<<endl ;
	cout<<"\t2) Stringa"<<endl ;
	cin>>scelta ; 
    } while(scelta < 1 || scelta > 2) ;

    tipo_chiave_t tipo_chiave ;
    switch(scelta) {
    case 1: tipo_chiave = CHIAVE_NUMERICA ; break ;
    case 2: tipo_chiave = CHIAVE_STRINGA ; break ;
    default: cout<<"Errore inatteso"<<endl ; return 1 ;
    }

    inizializza(sequenza, tipo_chiave) ;

    
    char menu[] =
	"\nOpzioni disponibili:\n\n"
	"\t1) Inserisci elemento\n"
	"\t2) Cerca elemento\n"
	"\t3) Elimina elemento\n"
	"\t4) Stampa sequenza\n"
	"\t5) Salva su file\n"
	"\t6) Carica da file\n"
	"\t0) Esci\n"
	"Scelta: " ;

    cout<<"Gestione sequenze."<<endl ;
    while(true) {
	cout<<menu ;

	int scelta ;
	cin>>scelta ;
	if (!cin) {
	    cin.clear() ;
	    cin.ignore() ;
	    continue ;
	}

	switch(scelta) {
	case 0:
	    return 0 ;
	case 1:{
	    do { 
		cout<<"Modalita' di inserimento:"<<endl ;
		cout<<"\t1) In testa"<<endl ;
		cout<<"\t2) In coda"<<endl ;
		if (sequenza.ordinata)
		    cout<<"\t3) In ordine"<<endl ;
		cin>>scelta ; 
	    } while(scelta < 1 || scelta > 3 || 
		    (!sequenza.ordinata && scelta > 2)) ;

	    ins_modo modo ;
	    switch(scelta) {
	    case 1: modo = in_testa ; break ;
	    case 2: modo = in_coda ; break ;
	    case 3: modo = in_ordine; break ;
	    default: cout<<"Errore inatteso"<<endl ; return 1 ;
	    }
	    elem *el = new elem ;
	    el->parole = 0 ;
	    cout<<"Dati elemento:"<<endl ;
	    cout<<"Chiave: " ;
	    cin>>el->chiave ;
	    cout<<"Numero di parole: " ;
	    cin>>el->num_parole ;
	    if (el->num_parole > 0) {
		el->parole = new char[el->num_parole][MAXLUN] ;
		for (int i = 0 ; i < el->num_parole ; i++) {
		    cout<<"Parola: " ;
		    cin>>el->parole[i] ;
		}
	    }
	    inserisci(sequenza, el, modo) ;}
	    break ;
	case 2: {
	    char c[MAXLUN] ;
	    cout<<"Chiave: " ;
	    cin>>c ;
	    int pos = cerca(sequenza, c) ;
	    if (pos == -1)
		cout<<"Elemento non trovato"<<endl ;
	    else {
		cout<<"Elemento trovato: "<<endl ;
		stampa_elem(*sequenza.elementi[pos], cout) ;
	    } }
	    break ;
	case 3: {
	    char c[MAXLUN] ;
	    cout<<"Chiave: " ;
	    cin>>c ;
	    if (!elimina(sequenza, c))
		cout<<"Elemento non trovato"<<endl ;
	    else 
		cout<<"Elemento eliminato"<<endl ; }
	    break ;
	case 4:
	    stampa(sequenza) ;
	    break ;
	case 5:
	    salva(sequenza, "sequenza.txt") ;
	    break ;
	default:
	    cout<<"Scelta non valida"<<endl ;
	}
    }

    return 0 ;
}
